/* -*- Mode: java; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is JavaScript Engine testing utilities.
 *
 * The Initial Developer of the Original Code is
 * Mozilla Foundation.
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Aaron Boodman
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

gTestfile = 'regress-308111.js';

var summary = "Regression - Do not crash when searching large e4x tree";
var BUGNUMBER = 308111;
var actual = 'No Crash';
var expect = 'No Crash';

printBugNumber(BUGNUMBER);
START(summary);

var xml = <prefs>
<pref><name>sessionsaver.settings.shutdown</name></pref>
<pref><name>network.http.max-persistent-connections-per-proxy</name></pref>
<pref><name>font.default.x-baltic</name></pref>
<pref><name>plugin.scan.Quicktime</name></pref>
<pref><name>capability.policy.default.DOMException.code</name></pref>
<pref><name>capability.policy.mailnews.*.innerHTML.get</name></pref>
<pref><name>capability.policy.mailnews.WebServiceProxyFactory.createProxy</name></pref>
<pref><name>capability.policy.mailnews.SchemaLoader.load</name></pref>
<pref><name>mousewheel.withcontrolkey.action</name></pref>
<pref><name>font.name.monospace.x-western</name></pref>
<pref><name>javascript.options.showInConsole</name></pref>
<pref><name>font.name.sans-serif.x-unicode</name></pref>
<pref><name>capability.policy.mailnews.SOAPEncoding.setDecoder</name></pref>
<pref><name>font.name-list.sans-serif.ko</name></pref>
<pref><name>browser.chrome.site_icons</name></pref>
<pref><name>app.update.auto</name></pref>
<pref><name>security.ssl2.des_64</name></pref>
<pref><name>print.always_cache_old_pres</name></pref>
<pref><name>security.ssl3.rsa_des_sha</name></pref>
<pref><name>security.warn_entering_weak.show_once</name></pref>
<pref><name>network.proxy.http_port</name></pref>
<pref><name>browser.display.use_document_colors</name></pref>
<pref><name>browser.preferences.animateFadeIn</name></pref>
<pref><name>browser.search.defaultenginename</name></pref>
<pref><name>capability.principal.codebase.p0.id</name></pref>
<pref><name>config.use_system_prefs</name></pref>
<pref><name>font.name.monospace.x-guru</name></pref>
<pref><name>security.default_personal_cert</name></pref>
<pref><name>bidi.controlstextmode</name></pref>
<pref><name>print.show_print_progress</name></pref>
<pref><name>network.http.max-connections-per-server</name></pref>
<pref><name>profile.migration_behavior</name></pref>
<pref><name>browser.chrome.image_icons.max_size</name></pref>
<pref><name>mousewheel.horizscroll.withaltkey.action</name></pref>
<pref><name>capability.policy.mailnews.XMLHttpRequest.onerror</name></pref>
<pref><name>greasemonkey.version</name></pref>
<pref><name>browser.search.order.Yahoo.2</name></pref>
<pref><name>font.name.sans-serif.ko</name></pref>
<pref><name>network.proxy.type</name></pref>
<pref><name>security.dialog_enable_delay</name></pref>
<pref><name>network.prefetch-next</name></pref>
<pref><name>alerts.slideIncrement</name></pref>
<pref><name>browser.blink_allowed</name></pref>
<pref><name>font.name.sans-serif.x-geor</name></pref>
<pref><name>font.name-list.sans-serif.zh-HK</name></pref>
<pref><name>print.print_footerright</name></pref>
<pref><name>capability.policy.default.History.item</name></pref>
<pref><name>browser.download.manager.showAlertOnComplete</name></pref>
<pref><name>capability.policy.default.Location.reload.get</name></pref>
<pref><name>network.IDN_show_punycode</name></pref>
<pref><name>browser.startup.homepage</name></pref>
<pref><name>network.protocol-handler.external.vbscript</name></pref>
<pref><name>signon.expireMasterPassword</name></pref>
<pref><name>capability.policy.mailnews.SchemaLoader.loadAsync</name></pref>
<pref><name>capability.policy.default.DOMException.toString.get</name></pref>
<pref><name>capability.policy.mailnews.XMLHttpRequest.readyState</name></pref>
<pref><name>capability.policy.default.History.back.get</name></pref>
<pref><name>slider.snapMultiplier</name></pref>
<pref><name>capability.policy.mailnews.XMLHttpRequest.abort</name></pref>
<pref><name>images.dither</name></pref>
<pref><name>print.print_headercenter</name></pref>
<pref><name>font.name.monospace.zh-HK</name></pref>
<pref><name>capability.policy.mailnews.HTMLAnchorElement.toString</name></pref>
<pref><name>font.name.serif.x-mlym</name></pref>
<pref><name>font.name.monospace.tr</name></pref>
<pref><name>advanced.mailftp</name></pref>
<pref><name>security.ssl3.rsa_fips_des_ede3_sha</name></pref>
<pref><name>application.use_ns_plugin_finder</name></pref>
<pref><name>font.name-list.cursive.ko</name></pref>
<pref><name>capability.policy.mailnews.*.data.get</name></pref>
<pref><name>browser.forms.submit.backwards_compatible</name></pref>
<pref><name>font.name.monospace.x-mlym</name></pref>
<pref><name>ui.key.menuAccessKey</name></pref>
<pref><name>capability.policy.mailnews.XMLHttpRequest.statusText</name></pref>
<pref><name>font.name.sans-serif.x-tamil</name></pref>
<pref><name>print.print_footercenter</name></pref>
<pref><name>privacy.item.sessions</name></pref>
<pref><name>network.ftp.idleConnectionTimeout</name></pref>
<pref><name>mousewheel.withshiftkey.sysnumlines</name></pref>
<pref><name>security.ssl2.rc4_40</name></pref>
<pref><name>font.size.variable.ko</name></pref>
<pref><name>capability.policy.default.Window.focus.get</name></pref>
<pref><name>font.size.fixed.ja</name></pref>
<pref><name>browser.display.focus_ring_on_anything</name></pref>
<pref><name>capability.policy.default_policynames</name></pref>
<pref><name>network.IDN.whitelist.kr</name></pref>
<pref><name>network.IDN.whitelist.br</name></pref>
<pref><name>network.cookie.alwaysAcceptSessionCookies</name></pref>
<pref><name>dom.disable_window_status_change</name></pref>
<pref><name>app.update.channel</name></pref>
<pref><name>network.proxy.ssl_port</name></pref>
<pref><name>xpinstall.whitelist.required</name></pref>
<pref><name>browser.tabs.opentabfor.middleclick</name></pref>
<pref><name>font.size.variable.x-tamil</name></pref>
<pref><name>layout.word_select.eat_space_to_next_word</name></pref>
<pref><name>security.warn_submit_insecure</name></pref>
<pref><name>network.negotiate-auth.gsslib</name></pref>
<pref><name>mousewheel.withaltkey.action</name></pref>
<pref><name>capability.policy.default.Window.top</name></pref>
<pref><name>font.name.cursive.x-ethi</name></pref>
<pref><name>browser.goBrowsing.enabled</name></pref>
<pref><name>capability.policy.mailnews.SOAPEncoding.encode</name></pref>
<pref><name>font.name.sans-serif.x-guru</name></pref>
<pref><name>plugin.expose_full_path</name></pref>
<pref><name>capability.policy.default.Window.closed</name></pref>
<pref><name>font.default.x-armn</name></pref>
<pref><name>capability.policy.mailnews.SOAPEncoding.styleURI</name></pref>
<pref><name>font.name.sans-serif.x-mlym</name></pref>
<pref><name>security.ssl3.rsa_null_sha</name></pref>
<pref><name>capability.policy.default.Window.opener</name></pref>
<pref><name>extensions.dss.switchPending</name></pref>
<pref><name>roaming.showInitialWarning</name></pref>
<pref><name>security.ssl3.dhe_dss_des_sha</name></pref>
<pref><name>network.protocol-handler.external.disk</name></pref>
<pref><name>font.name.serif.ja</name></pref>
<pref><name>custtoolbar.personal_toolbar_folder</name></pref>
<pref><name>capability.policy.mailnews.Window.sizeToContent</name></pref>
<pref><name>capability.policy.default.XMLHttpRequest.channel</name></pref>
<pref><name>capability.policy.mailnews.SOAPEncoding.schemaCollection</name></pref>
<pref><name>browser.display.normal_lineheight_calc_control</name></pref>
<pref><name>capability.policy.default.Location.replace.get</name></pref>
<pref><name>font.name.cursive.ko</name></pref>
<pref><name>accessibility.browsewithcaret</name></pref>
<pref><name>browser.cache.disk.enable</name></pref>
<pref><name>network.IDN.whitelist.de</name></pref>
<pref><name>general.useragent.locale</name></pref>
<pref><name>security.ssl2.rc2_40</name></pref>
<pref><name>network.cookie.prefsMigrated</name></pref>
<pref><name>plugin.scan.SunJRE</name></pref>
<pref><name>font.name.serif.x-armn</name></pref>
<pref><name>network.protocol-handler.external.data</name></pref>
<pref><name>nglayout.debug.disable_xul_cache</name></pref>
<pref><name>ime.password.onBlur.dontCare</name></pref>
<pref><name>capability.policy.mailnews.XMLHttpRequest.overrideMimeType</name></pref>
<pref><name>network.protocol-handler.external.mailto</name></pref>
<pref><name>print.use_global_printsettings</name></pref>
<pref><name>capability.policy.mailnews.XMLHttpRequest.getAllResponseHeaders</name></pref>
<pref><name>security.ssl3.rsa_aes_256_sha</name></pref>
<pref><name>capability.policy.mailnews.SOAPResponse.fault</name></pref>
<pref><name>mousewheel.withcontrolkey.sysnumlines</name></pref>
<pref><name>font.name.sans-serif.x-baltic</name></pref>
<pref><name>network.protocol-handler.expose.nntp</name></pref>
<pref><name>mousewheel.horizscroll.withcontrolkey.numlines</name></pref>
<pref><name>editor.htmlWrapColumn</name></pref>
<pref><name>browser.helperApps.alwaysAsk.force</name></pref>
<pref><name>security.ssl3.dhe_rsa_des_sha</name></pref>
<pref><name>network.proxy.no_proxies_on</name></pref>
<pref><name>network.protocol-handler.external.hcp</name></pref>
<pref><name>font.name.monospace.x-cans</name></pref>
<pref><name>browser.cache.disk_cache_ssl</name></pref>
<pref><name>intl.charsetmenu.browser.more1</name></pref>
<pref><name>accessibility.typeaheadfind.startlinksonly</name></pref>
<pref><name>editor.positioning.offset</name></pref>
<pref><name>font.name-list.monospace.x-tamil</name></pref>
<pref><name>network.proxy.gopher_port</name></pref>
<pref><name>mousewheel.horizscroll.withnokey.numlines</name></pref>
<pref><name>browser.history.grouping</name></pref>
<pref><name>pfs.datasource.url</name></pref>
<pref><name>network.http.max-persistent-connections-per-server</name></pref>
<pref><name>accessibility.tabfocus</name></pref>
<pref><name>network.cookie.p3plevel</name></pref>
<pref><name>intl.charsetmenu.browser.static</name></pref>
<pref><name>editor.css.default_length_unit</name></pref>
<pref><name>intl.charset.default</name></pref>
<pref><name>capability.policy.mailnews.SOAPPropertyBagMutator.addProperty</name></pref>
<pref><name>browser.download.folderList</name></pref>
<pref><name>font.name.sans-serif.tr</name></pref>
<pref><name>font.name-list.monospace.x-devanagari</name></pref>
<pref><name>font.name.sans-serif.x-devanagari</name></pref>
<pref><name>capability.policy.mailnews.Window.innerHeight.set</name></pref>
<pref><name>browser.tabs.warnOnClose</name></pref>
<pref><name>security.ssl3.rsa_des_ede3_sha</name></pref>
<pref><name>signed.applets.codebase_principal_support</name></pref>
<pref><name>print.extend_native_print_dialog</name></pref>
<pref><name>font.name-list.monospace.x-cans</name></pref>
<pref><name>font.name-list.serif.x-khmr</name></pref>
<pref><name>font.name.monospace.x-cyrillic</name></pref>
<pref><name>network.protocol-handler.warn-external.snews</name></pref>
<pref><name>permissions.default.image</name></pref>
<pref><name>font.name.monospace.ko</name></pref>
<pref><name>font.name-list.monospace.zh-TW</name></pref>
<pref><name>general.smoothScroll</name></pref>
<pref><name>font.name-list.serif.zh-CN</name></pref>
<pref><name>font.name.sans-serif.zh-TW</name></pref>
<pref><name>network.protocol-handler.warn-external.mailto</name></pref>
<pref><name>capability.policy.default.DOMException.name</name></pref>
<pref><name>font.name-list.serif.x-mlym</name></pref>
<pref><name>network.http.sendSecureXSiteReferrer</name></pref>
<pref><name>intl.charsetmenu.mailedit</name></pref>
<pref><name>capability.policy.mailnews.*.src.get</name></pref>
<pref><name>app.update.showInstalledUI</name></pref>
<pref><name>font.default.x-devanagari</name></pref>
<pref><name>dom.disable_window_open_feature.location</name></pref>
<pref><name>capability.policy.default.DOMException.result</name></pref>
<pref><name>font.name-list.monospace.x-beng</name></pref>
<pref><name>capability.policy.mailnews.XMLHttpRequest.getResponseHeader</name></pref>
<pref><name>accessibility.usebrailledisplay</name></pref>
<pref><name>network.enableIDN</name></pref>
<pref><name>font.name.cursive.tr</name></pref>
<pref><name>capability.policy.default.Location.href.set</name></pref>
<pref><name>font.size.fixed.zh-CN</name></pref>
<pref><name>font.name-list.sans-serif.zh-TW</name></pref>
<pref><name>network.protocol-handler.expose.snews</name></pref>
<pref><name>capability.policy.mailnews.SchemaLoader.onError</name></pref>
<pref><name>accessibility.typeaheadfind.timeout</name></pref>
<pref><name>capability.policy.default.History.next</name></pref>
<pref><name>font.size.fixed.x-geor</name></pref>
<pref><name>print.print_headerleft</name></pref>
<pref><name>browser.search.update</name></pref>
<pref><name>middlemouse.scrollbarPosition</name></pref>
<pref><name>capability.policy.mailnews.SOAPEncoding.decode</name></pref>
<pref><name>dom.disable_window_open_feature.scrollbars</name></pref>
<pref><name>security.ssl2.rc2_128</name></pref>
<pref><name>network.protocol-handler.external-default</name></pref>
<pref><name>dom.disable_window_open_feature.titlebar</name></pref>
<pref><name>startup.homepage_override_url</name></pref>
<pref><name>dom.popup_allowed_events</name></pref>
<pref><name>network.proxy.socks_port</name></pref>
<pref><name>capability.policy.default.Location.hash.set</name></pref>
<pref><name>browser.startup.page</name></pref>
<pref><name>print.whileInPrintPreview</name></pref>
<pref><name>font.default.x-khmr</name></pref>
<pref><name>mousewheel.withshiftkey.action</name></pref>
<pref><name>mousewheel.withaltkey.sysnumlines</name></pref>
<pref><name>font.size.fixed.x-baltic</name></pref>
<pref><name>capability.policy.mailnews.Window.moveBy</name></pref>
<pref><name>network.http.pipelining</name></pref>
<pref><name>plugin.override_internal_types</name></pref>
<pref><name>font.size.fixed.x-gujr</name></pref>
<pref><name>security.ssl2.des_ede3_192</name></pref>
<pref><name>browser.visited_color</name></pref>
<pref><name>capability.policy.mailnews.*.nodeValue.get</name></pref>
<pref><name>font.default.x-beng</name></pref>
<pref><name>intl.charsetmenu.browser.more4</name></pref>
<pref><name>network.http.keep-alive</name></pref>
<pref><name>ui.key.accelKey</name></pref>
<pref><name>privacy.popups.firstTime</name></pref>
<pref><name>browser.fixup.alternate.enabled</name></pref>
<pref><name>font.name-list.serif.x-cans</name></pref>
<pref><name>security.enable_ssl3</name></pref>
<pref><name>print.print_headerright</name></pref>
<pref><name>network.IDN.whitelist.th</name></pref>
<pref><name>capability.policy.mailnews.SOAPEncoding.unmapSchemaURI</name></pref>
<pref><name>capability.policy.mailnews.Range.toString</name></pref>
<pref><name>print.print_edge_bottom</name></pref>
<pref><name>network.IDN.blacklist_chars</name></pref>
<pref><name>browser.display.foreground_color</name></pref>
<pref><name>font.default.zh-CN</name></pref>
<pref><name>network.cookie.cookieBehavior</name></pref>
<pref><name>dom.disable_image_src_set</name></pref>
<pref><name>font.default.x-cans</name></pref>
<pref><name>capability.policy.mailnews.Window.screenY.set</name></pref>
<pref><name>network.cookie.enableForCurrentSessionOnly</name></pref>
<pref><name>app.update.timer</name></pref>
<pref><name>layout.word_select.stop_at_punctuation</name></pref>
<pref><name>browser.search.order.Yahoo</name></pref>
<pref><name>middlemouse.paste</name></pref>
<pref><name>font.name.sans-serif.zh-HK</name></pref>
<pref><name>dom.disable_window_open_feature.toolbar</name></pref>
<pref><name>dom.popup_maximum</name></pref>
<pref><name>security.warn_entering_secure</name></pref>
<pref><name>mousewheel.horizscroll.withaltkey.numlines</name></pref>
<pref><name>javascript.allow.mailnews</name></pref>
<pref><name>browser.tabs.warnOnCloseOther</name></pref>
<pref><name>intl.accept_charsets</name></pref>
<pref><name>font.name.monospace.x-central-euro</name></pref>
<pref><name>alerts.height</name></pref>
<pref><name>font.name-list.serif.x-tamil</name></pref>
<pref><name>capability.policy.mailnews.SchemaLoader.onLoad</name></pref>
<pref><name>font.size.variable.x-western</name></pref>
<pref><name>keyword.URL</name></pref>
<pref><name>capability.policy.default.Window.self</name></pref>
<pref><name>browser.dom.window.dump.enabled</name></pref>
<pref><name>font.name.sans-serif.x-beng</name></pref>
<pref><name>privacy.item.siteprefs</name></pref>
<pref><name>font.name.cursive.x-baltic</name></pref>
<pref><name>network.protocol-handler.external.nntp</name></pref>
<pref><name>security.ssl3.dhe_dss_des_ede3_sha</name></pref>
<pref><name>font.name.serif.x-western</name></pref>
<pref><name>capability.policy.mailnews.sites</name></pref>
<pref><name>font.name-list.serif.x-beng</name></pref>
<pref><name>dom.event.contextmenu.enabled</name></pref>
<pref><name>browser.urlbar.clickSelectsAll</name></pref>
<pref><name>security.warn_entering_secure.show_once</name></pref>
<pref><name>font.size.fixed.zh-HK</name></pref>
<pref><name>capability.policy.mailnews.SOAPCall.invoke</name></pref>
<pref><name>capability.policy.default.SOAPCall.invokeVerifySourceHeader</name></pref>
<pref><name>font.size.fixed.x-guru</name></pref>
<pref><name>viewmanager.do_doublebuffering</name></pref>
<pref><name>font.name.sans-serif.x-cans</name></pref>
<pref><name>capability.policy.mailnews.*.href.get</name></pref>
<pref><name>font.size.fixed.he</name></pref>
<pref><name>dom.max_script_run_time</name></pref>
<pref><name>capability.policy.default.Navigator.preference</name></pref>
<pref><name>security.ssl2.rc4_128</name></pref>
<pref><name>browser.link.open_newwindow</name></pref>
<pref><name>accessibility.tabfocus_applies_to_xul</name></pref>
<pref><name>security.ssl3.rsa_rc4_128_sha</name></pref>
<pref><name>font.size.variable.x-unicode</name></pref>
<pref><name>mousewheel.withcontrolkey.numlines</name></pref>
<pref><name>font.name.monospace.x-ethi</name></pref>
<pref><name>font.default.zh-HK</name></pref>
<pref><name>browser.tabs.loadBookmarksInBackground</name></pref>
<pref><name>browser.fixup.hide_user_pass</name></pref>
<pref><name>capability.policy.mailnews.HTMLDocument.URL</name></pref>
<pref><name>plugin.scan.Acrobat</name></pref>
<pref><name>font.name.serif.x-cyrillic</name></pref>
<pref><name>intl.accept_languages</name></pref>
<pref><name>capability.policy.mailnews.*.host.get</name></pref>
<pref><name>security.directory</name></pref>
<pref><name>security.ssl3.dhe_rsa_aes_128_sha</name></pref>
<pref><name>font.size.variable.zh-HK</name></pref>
<pref><name>browser.display.use_focus_colors</name></pref>
<pref><name>capability.policy.default.DOMException.message</name></pref>
<pref><name>intl.charsetmenu.browser.unicode</name></pref>
<pref><name>greasemonkey.editor</name></pref>
<pref><name>intl.charsetmenu.composer.cache</name></pref>
<pref><name>font.default.x-tamil</name></pref>
<pref><name>capability.policy.default.DOMParser.parseFromStream</name></pref>
<pref><name>network.http.version</name></pref>
<pref><name>capability.policy.default.History.previous</name></pref>
<pref><name>signon.SignonFileName</name></pref>
<pref><name>font.name.monospace.zh-CN</name></pref>
<pref><name>app.update.silent</name></pref>
<pref><name>font.name-list.monospace.x-mlym</name></pref>
<pref><name>browser.underline_anchors</name></pref>
<pref><name>capability.policy.default.Navigator.preferenceinternal.set</name></pref>
<pref><name>intl.jis0208.map</name></pref>
<pref><name>network.automatic-ntlm-auth.trusted-uris</name></pref>
<pref><name>browser.chrome.toolbar_tips</name></pref>
<pref><name>mousewheel.withshiftkey.numlines</name></pref>
<pref><name>font.name.sans-serif.x-western</name></pref>
<pref><name>browser.download.manager.showWhenStarting</name></pref>
<pref><name>browser.enable_automatic_image_resizing</name></pref>
<pref><name>privacy.item.passwords</name></pref>
<pref><name>app.update.incompatible.mode</name></pref>
<pref><name>capability.policy.mailnews.WSDLLoader.loadAsync</name></pref>
<pref><name>capability.policy.mailnews.SOAPEncoding.getAssociatedEncoding</name></pref>
<pref><name>browser.sessionhistory.max_entries</name></pref>
<pref><name>sessionsaver.windows.cookies</name></pref>
<pref><name>network.image.warnAboutImages</name></pref>
<pref><name>browser.cache.disk.capacity</name></pref>
<pref><name>font.size.variable.ja</name></pref>
<pref><name>plugin.scan.plid.all</name></pref>
<pref><name>print.print_extra_margin</name></pref>
<pref><name>browser.download.manager.focusWhenStarting</name></pref>
<pref><name>capability.policy.mailnews.XMLHttpRequest.channel</name></pref>
<pref><name>font.name.sans-serif.x-armn</name></pref>
<pref><name>network.proxy.socks_version</name></pref>
<pref><name>xpinstall.whitelist.add.103</name></pref>
<pref><name>browser.download.manager.alertOnEXEOpen</name></pref>
<pref><name>network.IDN.whitelist.ch</name></pref>
<pref><name>xpinstall.dialog.progress.chrome</name></pref>
<pref><name>network.online</name></pref>
<pref><name>capability.policy.default.HTMLDocument.open.get</name></pref>
<pref><name>general.startup.browser</name></pref>
<pref><name>security.OCSP.enabled</name></pref>
<pref><name>font.size.fixed.x-khmr</name></pref>
<pref><name>config.use_system_prefs.accessibility</name></pref>
<pref><name>font.default.ja</name></pref>
<pref><name>print.print_edge_top</name></pref>
<pref><name>print.print_edge_left</name></pref>
<pref><name>network.dns.ipv4OnlyDomains</name></pref>
<pref><name>browser.tabs.autoHide</name></pref>
<pref><name>browser.search.order.2</name></pref>
<pref><name>font.name.sans-serif.he</name></pref>
<pref><name>browser.tabs.loadGroup</name></pref>
<pref><name>font.name.monospace.x-beng</name></pref>
<pref><name>intl.locale.matchOS</name></pref>
<pref><name>font.name.serif.zh-CN</name></pref>
<pref><name>capability.policy.mailnews.*.protocol.get</name></pref>
<pref><name>network.IDN.whitelist.tm</name></pref>
<pref><name>network.cookie.denyRemovedCookies</name></pref>
<pref><name>browser.search.order.Yahoo.1</name></pref>
<pref><name>font.size.fixed.x-ethi</name></pref>
<pref><name>sessionsaver.prefs_set</name></pref>
<pref><name>alerts.totalOpenTime</name></pref>
<pref><name>browser.tabs.loadInBackground</name></pref>
<pref><name>mousewheel.horizscroll.withnokey.sysnumlines</name></pref>
<pref><name>network.negotiate-auth.using-native-gsslib</name></pref>
<pref><name>accessibility.warn_on_browsewithcaret</name></pref>
<pref><name>security.ssl3.rsa_fips_des_sha</name></pref>
<pref><name>network.protocol-handler.external.shell</name></pref>
<pref><name>ui.key.generalAccessKey</name></pref>
<pref><name>font.size.variable.zh-CN</name></pref>
<pref><name>network.automatic-ntlm-auth.allow-proxies</name></pref>
<pref><name>capability.policy.mailnews.Window.moveTo</name></pref>
<pref><name>nglayout.events.dispatchLeftClickOnly</name></pref>
<pref><name>font.name.serif.x-devanagari</name></pref>
<pref><name>security.checkloaduri</name></pref>
<pref><name>network.protocol-handler.external.javascript</name></pref>
<pref><name>security.ssl3.rsa_rc2_40_md5</name></pref>
<pref><name>network.IDN.whitelist.dk</name></pref>
<pref><name>mousewheel.horizscroll.withaltkey.sysnumlines</name></pref>
<pref><name>nglayout.debug.enable_xbl_forms</name></pref>
<pref><name>network.proxy.socks</name></pref>
<pref><name>font.size.variable.x-central-euro</name></pref>
<pref><name>network.IDN.whitelist.jp</name></pref>
<pref><name>font.size.variable.zh-TW</name></pref>
<pref><name>network.IDN.whitelist.museum</name></pref>
<pref><name>font.name-list.serif.zh-TW</name></pref>
<pref><name>browser.chrome.toolbar_style</name></pref>
<pref><name>mousewheel.horizscroll.withshiftkey.numlines</name></pref>
<pref><name>capability.policy.default.Window.close.get</name></pref>
<pref><name>capability.policy.mailnews.SOAPEncoding.defaultEncoder</name></pref>
<pref><name>browser.download.manager.retention</name></pref>
<pref><name>capability.policy.mailnews.*.baseURI.get</name></pref>
<pref><name>network.IDN.whitelist.fi</name></pref>
<pref><name>capability.policy.mailnews.WSDLLoader.load</name></pref>
<pref><name>network.protocol-handler.warn-external.news</name></pref>
<pref><name>dom.disable_open_during_load</name></pref>
<pref><name>general.useragent.extra.firefox</name></pref>
<pref><name>font.size.variable.x-ethi</name></pref>
<pref><name>font.default.tr</name></pref>
<pref><name>dom.disable_window_open_feature.resizable</name></pref>
<pref><name>sessionsaver.windows.session0</name></pref>
<pref><name>network.proxy.failover_timeout</name></pref>
<pref><name>general.skins.selectedSkin</name></pref>
<pref><name>font.name.monospace.x-unicode</name></pref>
<pref><name>network.protocol-handler.expose-all</name></pref>
<pref><name>privacy.item.downloads</name></pref>
<pref><name>font.name.monospace.el</name></pref>
<pref><name>browser.preferences.instantApply</name></pref>
<pref><name>font.name-list.serif.ko</name></pref>
<pref><name>editor.resizing.preserve_ratio</name></pref>
<pref><name>font.default.x-ethi</name></pref>
<pref><name>privacy.sanitize.promptOnSanitize</name></pref>
<pref><name>font.name.serif.x-cans</name></pref>
<pref><name>font.name-list.monospace.x-geor</name></pref>
<pref><name>network.hosts.nntp_server</name></pref>
<pref><name>font.size.variable.x-khmr</name></pref>
<pref><name>capability.policy.mailnews.*.text.get</name></pref>
<pref><name>network.protocol-handler.warn-external.nntp</name></pref>
<pref><name>font.default.x-unicode</name></pref>
<pref><name>capability.policy.mailnews.Window.resizeTo</name></pref>
<pref><name>font.name.monospace.zh-TW</name></pref>
<pref><name>font.default.ko</name></pref>
<pref><name>network.IDN.whitelist.tw</name></pref>
<pref><name>signon.rememberSignons</name></pref>
<pref><name>profile.manage_only_at_launch</name></pref>
<pref><name>security.warn_leaving_secure</name></pref>
<pref><name>font.language.group</name></pref>
<pref><name>network.http.pipelining.maxrequests</name></pref>
<pref><name>capability.policy.mailnews.WSDLLoader.onError</name></pref>
<pref><name>capability.policy.mailnews.Window.outerWidth.set</name></pref>
<pref><name>security.ask_for_password</name></pref>
<pref><name>capability.policy.mailnews.SOAPEncoding.defaultDecoder</name></pref>
<pref><name>font.default.x-gujr</name></pref>
<pref><name>capability.policy.mailnews.XMLSerializer.serializeToStream</name></pref>
<pref><name>network.autodial-helper.enabled</name></pref>
<pref><name>font.size.fixed.x-central-euro</name></pref>
<pref><name>alerts.slideIncrementTime</name></pref>
<pref><name>capability.policy.mailnews.Window.blur</name></pref>
<pref><name>network.http.accept.default</name></pref>
<pref><name>network.http.proxy.keep-alive</name></pref>
<pref><name>privacy.sanitize.sanitizeOnShutdown</name></pref>
<pref><name>capability.policy.mailnews.*.getNamedItemNS</name></pref>
<pref><name>network.protocol-handler.external.snews</name></pref>
<pref><name>layout.enable_japanese_specific_transform</name></pref>
<pref><name>general.useragent.contentlocale</name></pref>
<pref><name>ui.key.menuAccessKeyFocuses</name></pref>
<pref><name>plugin.scan.WindowsMediaPlayer</name></pref>
<pref><name>font.name.cursive.x-western</name></pref>
<pref><name>intl.charset.detector</name></pref>
<pref><name>browser.download.save_converter_index</name></pref>
<pref><name>image.animation_mode</name></pref>
<pref><name>network.http.sendRefererHeader</name></pref>
<pref><name>font.default.x-central-euro</name></pref>
<pref><name>plugin.default_plugin_disabled</name></pref>
<pref><name>network.protocol-handler.external.ms-help</name></pref>
<pref><name>font.default.x-geor</name></pref>
<pref><name>browser.download.manager.openDelay</name></pref>
<pref><name>dom.disable_window_open_feature.personalbar</name></pref>
<pref><name>capability.policy.mailnews.SOAPHeaderBlock.mustUnderstand</name></pref>
<pref><name>intl.keyboard.per_window_layout</name></pref>
<pref><name>network.dir.format</name></pref>
<pref><name>capability.policy.default.Clipboard.cutcopy</name></pref>
<pref><name>capability.policy.default.Window.window</name></pref>
<pref><name>font.name.sans-serif.x-ethi</name></pref>
<pref><name>print.use_native_print_dialog</name></pref>
<pref><name>browser.search.defaulturl</name></pref>
<pref><name>font.name-list.serif.zh-HK</name></pref>
<pref><name>network.negotiate-auth.trusted-uris</name></pref>
<pref><name>intl.charsetmenu.browser.cache</name></pref>
<pref><name>intl.menuitems.insertseparatorbeforeaccesskeys</name></pref>
<pref><name>network.protocol-handler.external.news</name></pref>
<pref><name>greasemonkey.enabled</name></pref>
<pref><name>capability.policy.mailnews.XMLHttpRequest.send</name></pref>
<pref><name>capability.policy.mailnews.SOAPEncoding.getEncoder</name></pref>
<pref><name>profile.seconds_until_defunct</name></pref>
<pref><name>font.size.variable.x-beng</name></pref>
<pref><name>mousewheel.horizscroll.withnokey.action</name></pref>
<pref><name>bidi.texttype</name></pref>
<pref><name>network.protocol-handler.expose.news</name></pref>
<pref><name>network.negotiate-auth.delegation-uris</name></pref>
<pref><name>font.name.serif.zh-TW</name></pref>
<pref><name>network.IDN.whitelist.gr</name></pref>
<pref><name>general.useragent.security</name></pref>
<pref><name>extensions.disabledObsolete</name></pref>
<pref><name>browser.download.manager.closeWhenDone</name></pref>
<pref><name>network.proxy.ftp_port</name></pref>
<pref><name>privacy.item.cookies</name></pref>
<pref><name>capability.policy.mailnews.*.lowSrc.get</name></pref>
<pref><name>font.name-list.serif.x-ethi</name></pref>
<pref><name>font.name.serif.x-unicode</name></pref>
<pref><name>pref.advanced.proxies.disable_button.reload</name></pref>
<pref><name>capability.policy.mailnews.XMLHttpRequest.onload</name></pref>
<pref><name>browser.download.show_plugins_in_list</name></pref>
<pref><name>font.size.fixed.th</name></pref>
<pref><name>font.size.fixed.zh-TW</name></pref>
<pref><name>print.save_print_settings</name></pref>
<pref><name>bidi.browser.ui</name></pref>
<pref><name>extensions.update.url</name></pref>
<pref><name>font.name-list.monospace.x-khmr</name></pref>
<pref><name>intl.charsetmenu.browser.more2</name></pref>
<pref><name>security.ssl3.dhe_dss_aes_256_sha</name></pref>
<pref><name>capability.policy.mailnews.document.load</name></pref>
<pref><name>security.ssl3.rsa_rc4_40_md5</name></pref>
<pref><name>privacy.item.cache</name></pref>
<pref><name>browser.search.param.Google.1.default</name></pref>
<pref><name>browser.active_color</name></pref>
<pref><name>font.name-list.monospace.zh-HK</name></pref>
<pref><name>browser.display.show_image_placeholders</name></pref>
<pref><name>ime.password.onFocus.dontCare</name></pref>
<pref><name>middlemouse.contentLoadURL</name></pref>
<pref><name>font.name-list.monospace.x-armn</name></pref>
<pref><name>svg.enabled</name></pref>
<pref><name>capability.policy.default.Window.location</name></pref>
<pref><name>dom.disable_window_flip</name></pref>
<pref><name>security.warn_submit_insecure.show_once</name></pref>
<pref><name>font.size.variable.x-cyrillic</name></pref>
<pref><name>font.size.fixed.x-western</name></pref>
<pref><name>font.size.variable.x-devanagari</name></pref>
<pref><name>capability.policy.mailnews.XMLSerializer.serializeToString</name></pref>
<pref><name>bidi.support</name></pref>
<pref><name>browser.display.background_color</name></pref>
<pref><name>capability.policy.default.History.go.get</name></pref>
<pref><name>font.size.variable.x-armn</name></pref>
<pref><name>font.size.variable.el</name></pref>
<pref><name>network.cookie.p3p</name></pref>
<pref><name>mousewheel.horizscroll.withcontrolkey.sysnumlines</name></pref>
<pref><name>app.update.url</name></pref>
<pref><name>font.name.cursive.he</name></pref>
<pref><name>network.http.redirection-limit</name></pref>
<pref><name>network.ntlm.send-lm-response</name></pref>
<pref><name>converter.html2txt.header_strategy</name></pref>
<pref><name>browser.offline</name></pref>
<pref><name>network.proxy.ftp</name></pref>
<pref><name>dom.disable_window_open_feature.directories</name></pref>
<pref><name>capability.policy.default.Clipboard.paste</name></pref>
<pref><name>browser.related.disabledForDomains</name></pref>
<pref><name>font.name.sans-serif.x-cyrillic</name></pref>
<pref><name>intl.charsetmenu.browser.cache.size</name></pref>
<pref><name>capability.policy.mailnews.SOAPCall.transportURI</name></pref>
<pref><name>browser.shell.checkDefaultBrowser</name></pref>
<pref><name>network.proxy.http</name></pref>
<pref><name>capability.policy.default.History.current</name></pref>
<pref><name>capability.policy.mailnews.SOAPFault.faultNamespaceURI</name></pref>
<pref><name>capability.policy.mailnews.*.getAttribute</name></pref>
<pref><name>capability.policy.mailnews.XMLHttpRequest.responseText</name></pref>
<pref><name>network.IDN.whitelist.sh</name></pref>
<pref><name>browser.cache.check_doc_frequency</name></pref>
<pref><name>layout.frames.force_resizability</name></pref>
<pref><name>capability.policy.default.Window.frames</name></pref>
<pref><name>app.update.url.manual</name></pref>
<pref><name>capability.policy.mailnews.SOAPFault.element</name></pref>
<pref><name>browser.trim_user_and_password</name></pref>
<pref><name>font.size.variable.tr</name></pref>
<pref><name>browser.fixup.alternate.suffix</name></pref>
<pref><name>browser.download.manager.showAlertInterval</name></pref>
<pref><name>security.warn_viewing_mixed.show_once</name></pref>
<pref><name>browser.helperApps.neverAsk.openFile</name></pref>
<pref><name>font.name.sans-serif.x-central-euro</name></pref>
<pref><name>capability.policy.mailnews.SOAPCall.asyncInvoke</name></pref>
<pref><name>mousewheel.withnokey.numlines</name></pref>
<pref><name>font.name.serif.tr</name></pref>
<pref><name>privacy.popups.showBrowserMessage</name></pref>
<pref><name>browser.feedview.showMenu</name></pref>
<pref><name>font.name-list.serif.x-gujr</name></pref>
<pref><name>browser.feedview.reloadInterval</name></pref>
<pref><name>security.ui.enable</name></pref>
<pref><name>editor.use_css</name></pref>
<pref><name>network.IDN.whitelist.io</name></pref>
<pref><name>browser.related.enabled</name></pref>
<pref><name>browser.sessionhistory.max_viewers</name></pref>
<pref><name>font.size.variable.x-guru</name></pref>
<pref><name>font.size.variable.x-gujr</name></pref>
<pref><name>network.protocol-handler.external.vnd.ms.radio</name></pref>
<pref><name>advanced.system.supportDDEExec</name></pref>
<pref><name>browser.tabs.opentabfor.urlbar</name></pref>
<pref><name>font.name.sans-serif.x-khmr</name></pref>
<pref><name>mousewheel.horizscroll.withshiftkey.sysnumlines</name></pref>
<pref><name>network.protocol-handler.external.afp</name></pref>
<pref><name>font.name-list.serif.x-guru</name></pref>
<pref><name>intl.charsetmenu.browser.more5</name></pref>
<pref><name>security.ssl3.rsa_rc4_128_md5</name></pref>
<pref><name>font.default.he</name></pref>
<pref><name>font.size.fixed.ko</name></pref>
<pref><name>font.name-list.monospace.ko</name></pref>
<pref><name>capability.policy.mailnews.XMLHttpRequest.onreadystatechange</name></pref>
<pref><name>print.print_edge_right</name></pref>
<pref><name>browser.popups.showPopupBlocker</name></pref>
<pref><name>app.update.nagTimer.restart</name></pref>
<pref><name>capability.policy.mailnews.Location.toString</name></pref>
<pref><name>font.default.x-cyrillic</name></pref>
<pref><name>font.size.fixed.x-unicode</name></pref>
<pref><name>clipboard.autocopy</name></pref>
<pref><name>font.name.monospace.ja</name></pref>
<pref><name>browser.tabs.loadFolderAndReplace</name></pref>
<pref><name>font.name.monospace.x-khmr</name></pref>
<pref><name>font.size.variable.x-baltic</name></pref>
<pref><name>font.name.serif.x-tamil</name></pref>
<pref><name>font.name-list.monospace.x-gujr</name></pref>
<pref><name>browser.urlbar.matchOnlyTyped</name></pref>
<pref><name>capability.policy.mailnews.SOAPHeaderBlock.actorURI</name></pref>
<pref><name>font.name-list.sans-serif.zh-CN</name></pref>
<pref><name>extensions.update.interval</name></pref>
<pref><name>network.IDN.whitelist.cn</name></pref>
<pref><name>font.size.variable.he</name></pref>
<pref><name>security.ssl3.dhe_rsa_des_ede3_sha</name></pref>
<pref><name>dom.disable_window_open_feature.close</name></pref>
<pref><name>font.name.cursive.el</name></pref>
<pref><name>bidi.characterset</name></pref>
<pref><name>font.name.cursive.x-unicode</name></pref>
<pref><name>network.proxy.share_proxy_settings</name></pref>
<pref><name>network.cookie.disableCookieForMailNews</name></pref>
<pref><name>general.config.obscure_value</name></pref>
<pref><name>capability.policy.mailnews.XMLHttpRequest.open</name></pref>
<pref><name>dom.allow_scripts_to_close_windows</name></pref>
<pref><name>network.IDN.whitelist.se</name></pref>
<pref><name>mousewheel.horizscroll.withcontrolkey.action</name></pref>
<pref><name>capability.policy.mailnews.WebServiceProxyFactory.onLoad</name></pref>
<pref><name>browser.tabs.forceHide</name></pref>
<pref><name>accessibility.typeaheadfind.enablesound</name></pref>
<pref><name>font.size.fixed.x-cans</name></pref>
<pref><name>capability.policy.default.HTMLDocument.close.get</name></pref>
<pref><name>font.size.fixed.el</name></pref>
<pref><name>font.name.cursive.x-cyrillic</name></pref>
<pref><name>font.default.x-guru</name></pref>
<pref><name>browser.chromeURL</name></pref>
<pref><name>roaming.default.files</name></pref>
<pref><name>profile.confirm_automigration</name></pref>
<pref><name>browser.link.open_external</name></pref>
<pref><name>font.name-list.serif.x-armn</name></pref>
<pref><name>font.name.serif.el</name></pref>
<pref><name>font.name-list.monospace.ja</name></pref>
<pref><name>capability.policy.mailnews.SOAPEncoding.getInternalSchemaURI</name></pref>
<pref><name>browser.bookmarks.sort.direction</name></pref>
<pref><name>browser.download.manager.flashCount</name></pref>
<pref><name>browser.formfill.enable</name></pref>
<pref><name>font.size.fixed.x-beng</name></pref>
<pref><name>print.print_footerleft</name></pref>
<pref><name>capability.policy.default.Window.parent</name></pref>
<pref><name>capability.policy.mailnews.SOAPCall.verifySourceHeader</name></pref>
<pref><name>browser.download.lastDir</name></pref>
<pref><name>sessionsaver.windows.zorder</name></pref>
<pref><name>xpinstall.enabled</name></pref>
<pref><name>capability.policy.mailnews.*.getAttributeNS</name></pref>
<pref><name>capability.policy.mailnews.*.pathname.get</name></pref>
<pref><name>xpinstall.dialog.progress.type.skin</name></pref>
<pref><name>browser.windows.loadOnNewWindow</name></pref>
<pref><name>font.name-list.serif.he</name></pref>
<pref><name>browser.link.open_newwindow.restriction</name></pref>
<pref><name>font.name-list.monospace.he</name></pref>
<pref><name>font.name.sans-serif.ja</name></pref>
<pref><name>editor.singleLine.pasteNewlines</name></pref>
<pref><name>accessibility.typeaheadfind.soundURL</name></pref>
<pref><name>capability.policy.mailnews.Window.outerHeight.set</name></pref>
<pref><name>capability.policy.mailnews.SOAPFault.faultActor</name></pref>
<pref><name>font.size.fixed.tr</name></pref>
<pref><name>extensions.getMoreThemesURL</name></pref>
<pref><name>browser.search.param.Google.1.custom</name></pref>
<pref><name>extensions.logging.enabled</name></pref>
<pref><name>browser.frames.enabled</name></pref>
<pref><name>font.default.th</name></pref>
<pref><name>network.IDN.whitelist.lt</name></pref>
<pref><name>capability.policy.mailnews.SOAPEncoding.mapSchemaURI</name></pref>
<pref><name>network.hosts.smtp_server</name></pref>
<pref><name>mousewheel.withnokey.sysnumlines</name></pref>
<pref><name>browser.tabs.loadOnNewTab</name></pref>
<pref><name>font.name.sans-serif.el</name></pref>
<pref><name>browser.display.focus_ring_width</name></pref>
<pref><name>font.size.variable.x-mlym</name></pref>
<pref><name>font.name.serif.x-khmr</name></pref>
<pref><name>capability.policy.mailnews.XMLHttpRequest.status</name></pref>
<pref><name>intl.charsetmenu.mailview.cache</name></pref>
<pref><name>capability.policy.mailnews.SOAPEncoding.setEncoder</name></pref>
<pref><name>privacy.popups.usecustom</name></pref>
<pref><name>font.name-list.serif.x-geor</name></pref>
<pref><name>capability.policy.mailnews.WSDLLoader.onLoad</name></pref>
<pref><name>dom.disable_window_open_feature.minimizable</name></pref>
<pref><name>accessibility.typeaheadfind</name></pref>
<pref><name>capability.policy.mailnews.SOAPFault.detail</name></pref>
<pref><name>capability.policy.default.Window.document</name></pref>
<pref><name>font.size.variable.x-geor</name></pref>
<pref><name>xpinstall.dialog.confirm</name></pref>
<pref><name>intl.collationOption</name></pref>
<pref><name>browser.cache.memory.enable</name></pref>
<pref><name>font.size.variable.x-cans</name></pref>
<pref><name>browser.hiddenWindowChromeURL</name></pref>
<pref><name>font.name-list.serif.x-devanagari</name></pref>
<pref><name>capability.principal.codebase.p0.subjectName</name></pref>
<pref><name>capability.policy.mailnews.*.hostname.get</name></pref>
<pref><name>intl.fallbackCharsetList.ISO-8859-1</name></pref>
<pref><name>network.IDN.whitelist.li</name></pref>
<pref><name>javascript.options.strict</name></pref>
<pref><name>font.name.cursive.ar</name></pref>
<pref><name>browser.search.selectedEngine</name></pref>
<pref><name>capability.policy.mailnews.SOAPEncoding.getDecoder</name></pref>
<pref><name>general.autoScroll</name></pref>
<pref><name>font.default.x-western</name></pref>
<pref><name>browser.display.use_system_colors</name></pref>
<pref><name>extensions.ignoreMTimeChanges</name></pref>
<pref><name>network.hosts.pop_server</name></pref>
<pref><name>privacy.item.history</name></pref>
<pref><name>editor.quotesPreformatted</name></pref>
<pref><name>security.password_lifetime</name></pref>
<pref><name>security.ssl3.dhe_dss_aes_128_sha</name></pref>
<pref><name>font.name.monospace.x-tamil</name></pref>
<pref><name>xpinstall.dialog.progress.type.chrome</name></pref>
<pref><name>capability.policy.mailnews.SchemaLoader.processSchemaElement</name></pref>
<pref><name>capability.policy.mailnews.DOMParser,parseFromString</name></pref>
<pref><name>network.http.proxy.pipelining</name></pref>
<pref><name>security.ssl3.rsa_1024_rc4_56_sha</name></pref>
<pref><name>browser.history_expire_days</name></pref>
<pref><name>capability.policy.mailnews.DOMException.toString</name></pref>
<pref><name>font.name.serif.x-gujr</name></pref>
<pref><name>browser.display.force_inline_alttext</name></pref>
<pref><name>security.ssl3.rsa_1024_des_cbc_sha</name></pref>
<pref><name>mousewheel.horizscroll.withshiftkey.action</name></pref>
<pref><name>font.size.fixed.x-mlym</name></pref>
<pref><name>font.name-list.cursive.he</name></pref>
<pref><name>capability.policy.mailnews.Window.screenX.set</name></pref>
<pref><name>font.name.serif.x-ethi</name></pref>
<pref><name>network.cookie.lifetime.days</name></pref>
<pref><name>view_source.wrap_long_lines</name></pref>
<pref><name>network.IDN.whitelist.hu</name></pref>
<pref><name>browser.bookmarks.sort.resource</name></pref>
<pref><name>capability.policy.mailnews.*.getNamedItem</name></pref>
<pref><name>security.warn_viewing_mixed</name></pref>
<pref><name>browser.xul.error_pages.enabled</name></pref>
<pref><name>capability.policy.mailnews.WebServiceProxyFactory.createProxyAsync</name></pref>
<pref><name>capability.policy.mailnews.DOMParser,parseFromStream</name></pref>
<pref><name>network.proxy.autoconfig_url</name></pref>
<pref><name>capability.policy.mailnews.SOAPPropertyBagMutator.propertyBag</name></pref>
<pref><name>xpinstall.dialog.progress.skin</name></pref>
<pref><name>browser.download.hide_plugins_without_extensions</name></pref>
<pref><name>network.protocol-handler.warn-external-default</name></pref>
<pref><name>font.name.serif.he</name></pref>
<pref><name>font.name.cursive.th</name></pref>
<pref><name>network.negotiate-auth.allow-proxies</name></pref>
<pref><name>capability.policy.default.Window.Components</name></pref>
<pref><name>font.name.serif.x-central-euro</name></pref>
<pref><name>font.size.fixed.x-tamil</name></pref>
<pref><name>capability.policy.mailnews.SOAPFault.faultString</name></pref>
<pref><name>app.update.mode</name></pref>
<pref><name>font.name.serif.x-guru</name></pref>
<pref><name>capability.policy.mailnews.*.title.get</name></pref>
<pref><name>font.name.monospace.x-gujr</name></pref>
<pref><name>app.update.nagTimer.download</name></pref>
<pref><name>dom.disable_window_move_resize</name></pref>
<pref><name>browser.download.useDownloadDir</name></pref>
<pref><name>font.name.sans-serif.ar</name></pref>
<pref><name>network.IDN.whitelist.no</name></pref>
<pref><name>browser.display.screen_resolution</name></pref>
<pref><name>extensions.dss.enabled</name></pref>
<pref><name>network.http.request.max-start-delay</name></pref>
<pref><name>font.size.fixed.ar</name></pref>
<pref><name>extensions.update.enabled</name></pref>
<pref><name>network.auth.use-sspi</name></pref>
<pref><name>sessionsaver.settings.dontwarn</name></pref>
<pref><name>capability.policy.mailnews.Window.name.set</name></pref>
<pref><name>security.enable_tls</name></pref>
<pref><name>dom.disable_window_open_feature.menubar</name></pref>
<pref><name>xpinstall.whitelist.add</name></pref>
<pref><name>sessionsaver.settings.nofx</name></pref>
<pref><name>font.name.serif.ar</name></pref>
<pref><name>network.http.max-connections</name></pref>
<pref><name>browser.fixup.alternate.prefix</name></pref>
<pref><name>privacy.item.formdata</name></pref>
<pref><name>network.dns.disableIPv6</name></pref>
<pref><name>network.protocol-handler.external.disks</name></pref>
<pref><name>dom.disable_window_open_feature.status</name></pref>
<pref><name>javascript.enabled</name></pref>
<pref><name>prefs.converted-to-utf8</name></pref>
<pref><name>capability.policy.mailnews.SOAPEncoding.getExternalSchemaURI</name></pref>
<pref><name>network.proxy.socks_remote_dns</name></pref>
<pref><name>capability.policy.mailnews.HTMLDocument.domain</name></pref>
<pref><name>font.name-list.monospace.zh-CN</name></pref>
<pref><name>font.default.zh-TW</name></pref>
<pref><name>capability.policy.mailnews.Window.resizeBy</name></pref>
<pref><name>browser.tabs.loadDivertedInBackground</name></pref>
<pref><name>app.update.interval</name></pref>
<pref><name>browser.related.provider</name></pref>
<pref><name>profile.allow_automigration</name></pref>
<pref><name>browser.search.basic.min_ver</name></pref>
<pref><name>network.proxy.ssl</name></pref>
<pref><name>security.xpconnect.plugin.unrestricted</name></pref>
<pref><name>middlemouse.openNewWindow</name></pref>
<pref><name>dom.disable_open_click_delay</name></pref>
<pref><name>network.enablePad</name></pref>
<pref><name>font.name.serif.x-baltic</name></pref>
<pref><name>privacy.popups.disable_from_plugins</name></pref>
<pref><name>font.name-list.monospace.x-guru</name></pref>
<pref><name>security.ssl3.rsa_aes_128_sha</name></pref>
<pref><name>capability.policy.mailnews.Window.innerWidth.set</name></pref>
<pref><name>security.enable_ssl2</name></pref>
<pref><name>font.name.monospace.th</name></pref>
<pref><name>capability.policy.mailnews.WebServiceProxyFactory.onError</name></pref>
<pref><name>network.protocol-handler.expose.mailto</name></pref>
<pref><name>font.default.el</name></pref>
<pref><name>network.http.default-socket-type</name></pref>
<pref><name>browser.display.focus_background_color</name></pref>
<pref><name>editor.use_custom_colors</name></pref>
<pref><name>network.proxy.gopher</name></pref>
<pref><name>ui.key.saveLink.shift</name></pref>
<pref><name>font.name.serif.ko</name></pref>
<pref><name>security.warn_entering_weak</name></pref>
<pref><name>font.name.sans-serif.th</name></pref>
<pref><name>capability.policy.mailnews.*.substringData.get</name></pref>
<pref><name>font.name.cursive.x-central-euro</name></pref>
<pref><name>browser.chrome.favicons</name></pref>
<pref><name>font.size.variable.ar</name></pref>
<pref><name>accessibility.typeaheadfind.autostart</name></pref>
<pref><name>font.default.ar</name></pref>
<pref><name>capability.policy.mailnews.SOAPFault.faultCode</name></pref>
<pref><name>font.name.serif.th</name></pref>
<pref><name>security.ssl3.dhe_rsa_aes_256_sha</name></pref>
<pref><name>privacy.popups.policy</name></pref>
<pref><name>font.name.monospace.he</name></pref>
<pref><name>font.name.sans-serif.x-gujr</name></pref>
<pref><name>browser.anchor_color</name></pref>
<pref><name>network.http.keep-alive.timeout</name></pref>
<pref><name>network.IDN.whitelist.cl</name></pref>
<pref><name>browser.display.focus_text_color</name></pref>
<pref><name>accessibility.typeaheadfind.linksonly</name></pref>
<pref><name>mousewheel.withaltkey.numlines</name></pref>
<pref><name>capability.policy.mailnews.Window.focus</name></pref>
<pref><name>intl.content.langcode</name></pref>
<pref><name>browser.helperApps.neverAsk.saveToDisk</name></pref>
<pref><name>browser.throbber.url</name></pref>
<pref><name>intl.menuitems.alwaysappendaccesskeys</name></pref>
<pref><name>font.size.fixed.x-armn</name></pref>
<pref><name>font.name.monospace.x-geor</name></pref>
<pref><name>accessibility.typeaheadfind.flashBar</name></pref>
<pref><name>font.name.monospace.x-devanagari</name></pref>
<pref><name>font.name.serif.x-geor</name></pref>
<pref><name>network.IDN.whitelist.ac</name></pref>
<pref><name>browser.related.autoload</name></pref>
<pref><name>intl.charsetmenu.browser.more3</name></pref>
<pref><name>font.name.monospace.x-baltic</name></pref>
<pref><name>browser.download.manager.useWindow</name></pref>
<pref><name>font.size.fixed.x-devanagari</name></pref>
<pref><name>font.name-list.sans-serif.ja</name></pref>
<pref><name>browser.search.order.1</name></pref>
<pref><name>capability.policy.mailnews.XMLHttpRequest.responseXML</name></pref>
<pref><name>extensions.getMoreExtensionsURL</name></pref>
<pref><name>font.name.serif.x-beng</name></pref>
<pref><name>font.size.variable.th</name></pref>
<pref><name>network.http.use-cache</name></pref>
<pref><name>font.name.serif.zh-HK</name></pref>
<pref><name>security.ssl3.rsa_null_md5</name></pref>
<pref><name>capability.policy.default.Window.blur.get</name></pref>
<pref><name>extensions.lastAppVersion</name></pref>
<pref><name>font.name.monospace.ar</name></pref>
<pref><name>capability.policy.mailnews.SOAPParameter</name></pref>
<pref><name>accessibility.accesskeycausesactivation</name></pref>
<pref><name>security.warn_leaving_secure.show_once</name></pref>
<pref><name>network.cookie.lifetimePolicy</name></pref>
<pref><name>bidi.numeral</name></pref>
<pref><name>capability.policy.default.History.toString</name></pref>
<pref><name>view_source.syntax_highlight</name></pref>
<pref><name>capability.principal.codebase.p0.granted</name></pref>
<pref><name>font.name-list.monospace.x-ethi</name></pref>
<pref><name>network.http.proxy.version</name></pref>
<pref><name>converter.html2txt.structs</name></pref>
<pref><name>accessibility.usetexttospeech</name></pref>
<pref><name>capability.policy.default.Navigator.preferenceinternal.get</name></pref>
<pref><name>font.size.fixed.x-cyrillic</name></pref>
<pref><name>capability.policy.default.Window.history</name></pref>
<pref><name>bidi.direction</name></pref>
<pref><name>capability.policy.mailnews.*.attributes.get</name></pref>
<pref><name>sessionsaver.settings.sync.machineid</name></pref>
<pref><name>capability.policy.mailnews.XMLHttpRequest.setRequestHeader</name></pref>
<pref><name>app.update.enabled</name></pref>
<pref><name>network.IDN.whitelist.at</name></pref>
<pref><name>accessibility.typeaheadfind.enabletimeout</name></pref>
<pref><name>browser.display.use_document_fonts</name></pref>
<pref><name>font.name.sans-serif.zh-CN</name></pref>
<pref><name>browser.startup.homepage_override.mstone</name></pref>
<pref><name>profile.migration_directory</name></pref>
<pref><name>font.name-list.serif.ja</name></pref>
<pref><name>mousewheel.withnokey.action</name></pref>
<pref><name>network.http.accept-encoding</name></pref>
<pref><name>capability.policy.default.Window.length</name></pref>
<pref><name>font.default.x-mlym</name></pref>
<pref><name>security.enable_java</name></pref>
<pref><name>network.standard-url.escape-utf8</name></pref>
<pref><name>network.standard-url.encode-utf8</name></pref>
<pref><name>network.IDN.whitelist.info</name></pref>
<pref><name>font.name.monospace.x-armn</name></pref>
<pref><name>keyword.enabled</name></pref>
<pref><name>capability.policy.default.History.forward.get</name></pref>
</prefs>;

var i = 0;
for each (var pref in xml.pref) {
    printStatus(pref.name + ": " + xml.pref.(name == pref.name).length());
}

TEST(1, expect, actual);

END();
