/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is JavaScript Engine testing utilities.
 *
 * The Initial Developer of the Original Code is
 * Mozilla Foundation.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Brendan Eich
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var gTestfile = 'regress-411279.js';
//-----------------------------------------------------------------------------
var BUGNUMBER = 411279;
var summary = 'let declaration as direct child of switch body block';
var actual = 'No Crash';
var expect = 'No Crash';


//-----------------------------------------------------------------------------
test();
//-----------------------------------------------------------------------------

function test()
{
  enterFunc ('test');
  printBugNumber(BUGNUMBER);
  printStatus (summary);

  function f(x) 
  {
    var value = '';

    switch(x)
    {
    case 1:
      value = "1 " + y; 
      break; 
    case 2: 
      let y = 42;
      value = "2 " + y; 
      break; 
    default:
      value = "default " + y;
    }

    return value;
  }

  expect = 'function f(x) { var value = ""; switch (x) { '
    + 'case 1: value = "1 " + y;  break; '
    + 'case 2: let y = 42; value = "2 " + y;  break; ' 
    + 'default: value = "default " + y; } return value; }';

  actual = f + '';

  compareSource(expect, actual, summary);

  expect = '1 undefined';
  actual = f(1);
  reportCompare(expect, actual, summary + ': f(1)');

  expect = '2 42';
  actual = f(2);
  reportCompare(expect, actual, summary + ': f(2)');

  expect = 'default undefined';
  actual = f(3);
  reportCompare(expect, actual, summary + ': f(3)');
 
  exitFunc ('test');
}
